var CControladorPreguntes = function (idCanvas,alumne) {
	const urlWsExercicis = "http://"+CVarGlobal.urlServior+"/frm/wsExercicis.php";
	
	var jo = this;
	var prv=null;
	var events = new CEvents(idCanvas);
	var exercici = new CExercici();
	
	var seguent = false;
	var pantallaPrincipal = true;
	// Posicio 0 boto "seguent exercici".
	// Posicio 1 fons de pantalla.
	var btnGeneral = {};
	var btnRuta =["seguent.png","fons.jpg"];
	var numImages = btnRuta.length;
	
	var loadedImages = 0;
	
	carregarImatges();	
    
	function carregarImatges(){
		for (var i in btnRuta){
			btnGeneral[i] = new CImatge(events.canvas.width - 140,events.canvas.height-140);
			btnGeneral[i].imatge.onload = function(){
				if (++loadedImages>=numImages){
					redimensionarCanvas();
					drawImages();
				}
			};
        
			btnGeneral[i].imatge.src = "imatges/general/" + btnRuta[i];
			btnGeneral[i].nom = btnRuta[i].substring(0,btnRuta[i].length-4);
		}
		
	}
	
	function redimensionarCanvas(){
		var Tam = TamVentana();
		events.canvas.width=Tam[0]; 
		events.canvas.height=Tam[1]-45;

		for (var i in btnRuta){
			switch(btnGeneral[i].nom){
				case "fons":
					btnGeneral[i].rectX = 0;
					btnGeneral[i].rectY = 0;
				break;
				case "seguent":
					btnGeneral[i].rectX = events.canvas.width - btnGeneral[i].imatge.width;
					btnGeneral[i].rectY = events.canvas.height - btnGeneral[i].imatge.height;
				break;  	        	
				default:;
			}			
		}
		//drawImages();
		//dibuixarPantalla();
		// Si hi ha algun exercici cal redimensionar.
		//if (prv != null) prv.redimensionar();	        
   	}

	this.dibuixar = function(){
		dibuixarPlantilla(events);		
	}
	
	function dibuixarPlantilla(e){
		e.clear();
		//dibuixar fons	
		e.context.drawImage(btnGeneral[1].imatge, btnGeneral[1].rectX, btnGeneral[1].rectY, e.canvas.width, e.canvas.height);	            	

		e.beginRegion();

		if (btnGeneral[0].seleccionat){
			dibContornBoto(this.context,0);
		} else {
			e.context.drawImage(btnGeneral[0].imatge, btnGeneral[0].rectX, btnGeneral[0].rectY, btnGeneral[0].imatge.width, btnGeneral[0].imatge.height);	            	
		}
	
		e.context.beginPath();
		e.context.rect(btnGeneral[0].rectX, btnGeneral[0].rectY, btnGeneral[0].imatge.width, btnGeneral[0].imatge.height);
		e.context.closePath();
		
		def_events(e,"mouseup",0);			
		def_events(e,"touchend",0);

		e.closeRegion();		
	}

	function drawImages(){

		events.setDrawStage(dibuixarPantalla);
	}

	
	function dibuixarPantalla(){
			dibuixarPlantilla(this);

			if (seguent){
				seguent = false;
				pantallaPrincipal = false;				
				if (prv != null){
					ajaxDesarPregunta(exercici.exercici,alumne,exercici.dataAssignacio,prv.obtNota());					
					prv = null;
				}
				ajaxSeguentPregunta(alumne);
				switch(exercici.tipus){
					case "tTest": 	prv = new CPreguntesTest(this,exercici,jo);	break;
					case "tTarja":	prv = new CTarjetes(this,exercici,jo); break;  	        	
					case "tCaixa":	prv = new CArrosegarImages(this,exercici,jo); break;
					default:;
				}
			}

			if( prv != null){
				prv.dibuixar();
			}

			else {
				if (pantallaPrincipal){
					//dibuixar pantalla principal
					//
					//alert(utf8_encode("Prem el bot continuar per realitzar els exercicis pendents. (Bot que s troba a la part de sota a la dreta de la pantalla)"));
					CText.escriureText(this.context,"Prem el bot\u00f3 continuar per realitzar els exercicis pendents. (Bot\u00f3 que es troba a la part de sota a la dreta de la pantalla)",this.canvas.width);
				}
				else {
					CText.escriureText(this.context,"No hi ha exercicis pendents.",this.canvas.width);
				}
			}
	}	
	
	function dibContornBoto(context,src){
		context.beginPath();
		context.rect(btnGeneral[src].rectX -5,btnGeneral[src].rectY-5,btnGeneral[src].imatge.width + 10,btnGeneral[src].imatge.height + 10);
		context.fillStyle ="#8ED6FF";
		context.fill();
		context.lineWidth=5;
		context.strokeStyle="black";
		context.stroke();
		context.closePath();
		context.drawImage(btnGeneral[src].imatge, btnGeneral[src].rectX, btnGeneral[src].rectY, btnGeneral[src].imatge.width, btnGeneral[src].imatge.height);		            	
	}
	
	function def_events(cont,strEvent,src){
		cont.addRegionEventListener(strEvent, function(){
			seguent = true;
			btnGeneral[0].seleccionat = false;
		});
		


	}

	function ajaxSeguentPregunta(alumne){
		$.ajax({
			type: "POST",
			url:urlWsExercicis,
			data:  {"tasca":"seguent","alumne":alumne},  
			async: false,
			dataType: 'json',
			success: tractarDades,
			error: function (obj, error, objError){
				//avisar que ocurri un error
				alert(error);
			}
		});	 
	}

	function tractarDades(dades){
		exercici = null;
		exercici = new CExercici();

		var dataJson = eval(dades);
		for(var i in dataJson){
			 exercici.tipus = dataJson[i].TIPUS;
			 exercici.pregunta = dataJson[i].PREGUNTA;
			 exercici.parametres = dataJson[i].PARAM;
			 exercici.exercici = dataJson[i].EXERCICI;
			 exercici.solucio = dataJson[i].SOLUCIO;
			 exercici.dataAssignacio = dataJson[i].DATA_ASSIGNACIO;
		}
	}

	function ajaxDesarPregunta(exercici,alumne,data_assignacio,nota){
		$.ajax({
			type: "POST",
			url:urlWsExercicis,
			data: {"tasca":"desarResultatExercici","exer":exercici,"alumne":alumne,"nota":nota,"data_assignacio":data_assignacio},
			async: false,
			success: tractarDadesDesar,
			error: function (obj, error, objError){
				alert(error);
			}
		});	 
	}

	function tractarDadesDesar(dades){
		//alert(dades);
		//var dataJson = JSON.parse(dades);
		var dataJson = eval(dades);
		for(var i in dataJson){
		//alert("desat? " + dataJson[i].TIPUS);
		}
	}
	
	function TamVentana() {
		var Tamanyo = [0, 0];
		if (typeof window.innerWidth != 'undefined'){
			Tamanyo = [window.innerWidth,window.innerHeight];
		}
		else
			if (typeof document.documentElement != 'undefined'
				&& typeof document.documentElement.clientWidth !=
				'undefined' && document.documentElement.clientWidth != 0){
				
				Tamanyo = [document.documentElement.clientWidth,document.documentElement.clientHeight];
			}
		else   {
			Tamanyo = [document.getElementsByTagName('body')[0].clientWidth,
				document.getElementsByTagName('body')[0].clientHeight];
		}
		
		return Tamanyo;
	}

	this.redim = function (){
		redimensionarCanvas();    	
	}

   

};

