<?php 

class CEstadistiques {
	private $bd;
	private $idEscola;
	private $idAlumne;
	private $idMestre;
	private $tipusEstadistica;
	
	const TIPUS_ALUMNE = 1;
	const TIPUS_MESTRE = 2;
	
	function __construct()
	{
		require_once("CBD.php");		
		$this->bd = new CBD();
		$params = func_get_args();
		$num_params = func_num_args();
		$funcion_constructor ='__construct'.$num_params;
		if (method_exists($this,$funcion_constructor)) {
			call_user_func_array(array($this,$funcion_constructor),$params);
		}
	}

	function __construct0()
	{
		$this->idEscola= "";
		$this->idAlumne = "";
		$this->idMestre = "";
		$tipusEstadistica = self::TIPUS_MESTRE;
	}

	function __construct2($idMestre,$idAlumne)
	{
		$this->idEscola= "";
		$this->idAlumne = $idAlumne;
		$this->idMestre = $idMestre;
		$tipusEstadistica = self::TIPUS_ALUMNE;
	}
		

	function __destruct() {
	}
	
	public function setIdEscola($idEscola){
		$this->idEscola = $idEscola;
	}	
	
	public function getIdEscola(){
		return $this->idEscola;
	}

	public function setIdMestre($idMestre){
		$this->idMestre = $idMestre;
	}	
	
	public function getIdMestre(){
		return $this->idMestre;
	}
	
	public function setIdAlumne($idAlumne){
		$this->idAlumne = $idAlumne;
	}	
	
	public function getIdAlumne(){
		return $this->idAlumne;
	}
	

	public function setIdTipusEstadistica($tipusEstadistica){
		$this->tipusEstadistica = $tipusEstadistica;
	}	
	
	public function getIdTipusEstadistica(){
		return $this->tipusEstadistica;
	}
	
	
	private function whereSegonsTipusEstadistica(){
		$strWhere = "";
		switch ($this->tipusEstadistica){
			case self::TIPUS_ALUMNE:
				$strWhere = 		" `exercicisassignats`.`alumne_email` = '$this->idAlumne' AND ";
				$strWhere = $strWhere.	" `exercicisassignats`.`mestre_email` ='$this->idMestre' ";
			break;
			case self::TIPUS_MESTRE:
				$strWhere = 		" `exercicisassignats`.`mestre_email` ='$this->idMestre' ";
			break;	
		}
		return $strWhere;		
	}
	
	public function getExercicisNoRealitzat($dataInicial,$dataFinal){
		
		$strWhere = $this->whereSegonsTipusEstadistica();
		
		$sql = $this->bd->sql(
					" SELECT COUNT(*) as qtt ".
					" FROM  `exercicisassignats` ".
					" WHERE 	`exercicisassignats`.`estatExercici` = 1 AND ".					
					"		'$dataInicial' <= `exercicisassignats`.`data_assignacio`  AND ".
					"		`exercicisassignats`.`data_assignacio`  <= '$dataFinal' AND ".
					$strWhere					
				);
		
		
		$data=mysql_fetch_assoc($sql);
		return (int)$data['qtt'];
		
	}
	
	public function getExercicisSuspesos($dataInicial,$dataFinal){
		
		$strWhere = $this->whereSegonsTipusEstadistica();
				
		$sql = $this->bd->sql( 	" SELECT COUNT(*) as qtt ".
					" FROM  `exercicisassignats` ".
					" WHERE 	`exercicisassignats`.`estatExercici` = 2 AND ".
					"		'$dataInicial' <= `exercicisassignats`.`data_assignacio`  AND ".
					"		`exercicisassignats`.`data_assignacio`  <= '$dataFinal' AND ".
					" `exercicisassignats`.`nota` < 5 AND ".
					$strWhere
					);

		$data=mysql_fetch_assoc($sql);
		return (int)$data['qtt'];
		
	}	

	public function getExercicisAprovats($dataInicial,$dataFinal){
				
		$strWhere = $this->whereSegonsTipusEstadistica();
		
		$sql = $this->bd->sql( 	
					" SELECT COUNT(*) as qtt ".
					" FROM  `exercicisassignats` ".
					" WHERE `exercicisassignats`.`estatExercici` = 2 AND ".
					"		'$dataInicial' <= `exercicisassignats`.`data_assignacio`  AND ".
					"		`exercicisassignats`.`data_assignacio`  <= '$dataFinal' AND ".
					"  5 <= `exercicisassignats`.`nota` AND ".
					$strWhere							
					);

		$data=mysql_fetch_assoc($sql);
		return (int)$data['qtt'];
		
	}		
	
	public function getExercicisPendentsXMes($dataInicial,$dataFinal){
				
		$strWhere = $this->whereSegonsTipusEstadistica();
			
		$sql = $this->bd->sql( 		
						" SELECT MONTH(`exercicisassignats`.`data_assignacio`) as mes ,`exercicisassignats`.`estatExercici`,count(*) as qtt ". 
						" FROM  `exercicisassignats`  ".
						" WHERE 	'$dataInicial' <= `exercicisassignats`.`data_assignacio`  AND ".
						"		`exercicisassignats`.`data_assignacio`  <= '$dataFinal'  AND ".
						" 		`exercicisassignats`.`estatExercici` = 1 AND ".						
						$strWhere.						
						" GROUP BY  MONTH(`exercicisassignats`.`data_assignacio`)  ".
						" ORDER BY MONTH(`exercicisassignats`.`data_assignacio`) " 		
						);

		return $sql;
		
	}		
	
	public function getExercicisAprovastsXMes($dataInicial,$dataFinal){
				
		$strWhere = $this->whereSegonsTipusEstadistica();	
		
		$sql = $this->bd->sql( 		
						" SELECT MONTH(`exercicisassignats`.`data_assignacio`) as mes ,`exercicisassignats`.`estatExercici`,count(*) as qtt ". 
						" FROM  `exercicisassignats`  ".
						" WHERE 	5<=`exercicisassignats`.nota AND ".
						"		'$dataInicial' <= `exercicisassignats`.`data_assignacio`  AND ".
						"		`exercicisassignats`.`data_assignacio`  <= '$dataFinal' AND ".
						" 		`exercicisassignats`.`estatExercici` = 2 AND ".
						$strWhere.
						" GROUP BY  MONTH(`exercicisassignats`.`data_assignacio`)  ".
						" ORDER BY MONTH(`exercicisassignats`.`data_assignacio`) " 		
						);

		return $sql;
		
	}		

	public function getExercicisSuspesosXMes($dataInicial,$dataFinal){
			
		$strWhere = $this->whereSegonsTipusEstadistica();
		
		$sql = $this->bd->sql( 		
						" SELECT MONTH(`exercicisassignats`.`data_assignacio`) as mes ,`exercicisassignats`.`estatExercici`,count(*) as qtt ". 
						" FROM  `exercicisassignats`  ".
						" WHERE `exercicisassignats`.nota < 5  AND ".
						"		'$dataInicial' <= `exercicisassignats`.`data_assignacio`  AND ".
						"		`exercicisassignats`.`data_assignacio`  <= '$dataFinal' AND ".					
						" 		`exercicisassignats`.`estatExercici` = 2 AND".
						$strWhere.
						" GROUP BY  MONTH(`exercicisassignats`.`data_assignacio`)  ".
						" ORDER BY MONTH(`exercicisassignats`.`data_assignacio`) " 		
						);

		return $sql;
		
	}
	
	
	public function getExercicisMitjanaXMes($dataInicial,$dataFinal){
		
		$strWhere = $this->whereSegonsTipusEstadistica();
		
		$sql = $this->bd->sql( 		
					" SELECT MONTH(`exercicisassignats`.`data_assignacio`) as mes ,`exercicisassignats`.`estatExercici`,avg(`exercicisassignats`.nota) as qtt  ".
					" FROM  `exercicisassignats`  ".
					" WHERE  	`exercicisassignats`.`estatExercici` = 2 AND ".
					"		'$dataInicial' <= `exercicisassignats`.`data_assignacio`  AND ".
					"		`exercicisassignats`.`data_assignacio`  <= '$dataFinal' AND ".
					$strWhere.
					" GROUP BY  MONTH(`exercicisassignats`.`data_assignacio`) ".
					" ORDER BY MONTH(`exercicisassignats`.`data_assignacio`)	 "					
					);

		return $sql;
		
	}	
}


?>